
Ruby - Bug #13656

Method#super_method returns incorrect result dependent on unrelated module

06/13/2017 04:40 PM - ccutrer (Cody Cutrer)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.4.1p111 (2017-03-22 revision

58053) [x86_64-darwin16]

Backport: 2.2: REQUIRED, 2.3: DONE, 2.4: DONE

Description

module Calculations

  def pluck

     puts "calculations"

  end

end

module Calculations2

  def pluck

    puts "calculations2"

    super

  end

end

class Relation

  include Calculations

end

Relation.prepend(Calculations2)

class CollectionProxy < Relation

  def pluck

    puts "collection_proxy"

    super

  end

end

module CollectionProxy2

  def unrelated

  end

end

# this is the critical line

CollectionProxy.prepend(CollectionProxy2)

ConcreteProxy = Class.new(CollectionProxy)

# these are the expected results

ConcreteProxy.new.method(:pluck).owner == CollectionProxy

ConcreteProxy.new.method(:pluck).super_method.owner == Calculations2

ConcreteProxy.new.method(:pluck).super_method.super_method.owner == Calculations

 The critical line is the CollectionProxy2 module. If I don't prepend it into CollectionProxy (or if I include it instead of prepend it), the

expected results pass. But when it is prepended, the owner for all super_methods will always be CollectionProxy, as if it can't find

any more ancestors (if you actually call ConcreteProxy.new.pluck it does call the three methods, in the correct order). So this is an

introspection only problem.

Associated revisions

Revision dbf67bf02db7afcca46b58e5b48fc7d805818e48 - 06/14/2017 06:03 AM - nobu (Nobuyoshi Nakada)

proc.c: skip prepended modules
proc.c (method_super_method): skip prepended modules and

continue from the super class of the original class.

[ruby-core:81666] [Bug #13656]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59080 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision dbf67bf0 - 06/14/2017 06:03 AM - nobu (Nobuyoshi Nakada)

proc.c: skip prepended modules

proc.c (method_super_method): skip prepended modules and

continue from the super class of the original class.

[ruby-core:81666] [Bug #13656]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59080 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 452f46b751a93a97fe42febebe8e8d5241752475 - 06/14/2017 01:08 PM - nobu (Nobuyoshi Nakada)

test/ruby/test_method.rb: refined  [ruby-core:81666] [Bug #13656]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59082 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 452f46b7 - 06/14/2017 01:08 PM - nobu (Nobuyoshi Nakada)

test/ruby/test_method.rb: refined  [ruby-core:81666] [Bug #13656]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59082 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 2459af86034b59136670cbfa14f369638232d55a - 06/30/2017 12:13 PM - U.Nakamura 

merge revision(s) 59080,59082: [Backport #13656]

    proc.c: skip prepended modules

    * proc.c (method_super_method): skip prepended modules and

      continue from the super class of the original class.

      [ruby-core:81666] [Bug #13656]

    test/ruby/test_method.rb: refined  [ruby-core:81666] [Bug #13656]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@59231 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 2459af86 - 06/30/2017 12:13 PM - U.Nakamura 

merge revision(s) 59080,59082: [Backport #13656]

    proc.c: skip prepended modules

    * proc.c (method_super_method): skip prepended modules and

      continue from the super class of the original class.

      [ruby-core:81666] [Bug #13656]

    test/ruby/test_method.rb: refined  [ruby-core:81666] [Bug #13656]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@59231 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision c358595ae42e1b5ed4647dd017d91cf3aa480740 - 07/23/2017 07:02 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 59080,59082: [Backport #13656]

    proc.c: skip prepended modules

    * proc.c (method_super_method): skip prepended modules and

      continue from the super class of the original class.

      [ruby-core:81666] [Bug #13656]

    test/ruby/test_method.rb: refined  [ruby-core:81666] [Bug #13656]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@59395 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision c358595a - 07/23/2017 07:02 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 59080,59082: [Backport #13656]

    proc.c: skip prepended modules

    * proc.c (method_super_method): skip prepended modules and

      continue from the super class of the original class.
      [ruby-core:81666] [Bug #13656]

    test/ruby/test_method.rb: refined  [ruby-core:81666] [Bug #13656]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@59395 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 06/14/2017 06:01 AM - nobu (Nobuyoshi Nakada)

- Description updated

- Backport changed from 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4: UNKNOWN to 2.2: REQUIRED, 2.3: REQUIRED, 2.4: REQUIRED

#2 - 06/14/2017 06:04 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r59080.

proc.c: skip prepended modules

proc.c (method_super_method): skip prepended modules and

continue from the super class of the original class.

[ruby-core:81666] [Bug #13656]

#3 - 06/30/2017 12:13 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.2: REQUIRED, 2.3: REQUIRED, 2.4: REQUIRED to 2.2: REQUIRED, 2.3: DONE, 2.4: REQUIRED

ruby_2_3 r59231 merged revision(s) 59080,59082.

#4 - 07/23/2017 07:02 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.2: REQUIRED, 2.3: DONE, 2.4: REQUIRED to 2.2: REQUIRED, 2.3: DONE, 2.4: DONE

ruby_2_4 r59395 merged revision(s) 59080,59082.
